/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*-

this file is part of rcssserver3D
Fri May 9 2003
Copyright (C) 2002,2003 Koblenz University
Copyright (C) 2003 RoboCup Soccer Server 3D Maintenance Group

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef AGENT3D_SOCCER_H
#define AGENT3D_SOCCER_H

#include "behavior.h"

class Soccer
    : public Behavior {
public:
    Soccer();
    virtual
    ~Soccer();

    virtual
    void think();

    virtual
    void behave() = 0;

    void setTeamName( const std::string& name )
      {
          M_team_name = name;
      }
    void setTeamUnum( int unum )
      {
          M_team_unum = unum;
      }

protected:
    //! atomic command
    void doCreateAgent();
    //! atomic command
    void doInitAgent();
    //! atomic command
    void doKick( const float angle, const float power );
    //! atomic command
    void doBeam( const salt::Vector3f & position );
    //! atomic command
    void doDrive( const salt::Vector3f & drive_vec );

    const
    salt::Vector3f & getDriveVec() const
      {
          return M_drive_vec;
      }

protected:
    /** the team name the agent uses with the init effector */
    std::string M_team_name;

    /** the uniform number the agent uses with the init effector. If
        left to zero, the server will allocate the next free number */
    int M_team_unum;

    /** the number of received sensations */
    int M_sensation_count;

    /** the state of the Drive effector */
    salt::Vector3f M_drive_vec;
};

DECLARE_ABSTRACTCLASS(Soccer)

#endif // SOCCER_H
